"""Add user_payment_processor table

Revision ID: 0bd5099cd6b9
Revises: 3a461270a6f2
Create Date: 2025-06-13 12:15:40.479301

"""

# revision identifiers, used by Alembic.
revision = '0bd5099cd6b9'
down_revision = '3a461270a6f2'

from alembic import op
import sqlalchemy as sa


def upgrade():
    op.execute("""
    CREATE TABLE user_payment_processor (
        user_id integer NOT NULL REFERENCES "user"(id),
        payment_processor_id text NOT NULL,
        currency payment_currency NOT NULL,
        UNIQUE (user_id, currency)
    );

    INSERT INTO user_payment_processor (
        user_id, payment_processor_id, currency
    )
    SELECT id, payment_processor_id, 'USD'
    FROM "user"
    WHERE payment_processor_id IS NOT NULL;

    ALTER TABLE "user"
    DROP COLUMN payment_processor_id;
    """)


def downgrade():
    op.execute("""
    ALTER TABLE "user"
    ADD COLUMN payment_processor_id text;

    UPDATE "user"
    SET payment_processor_id = pp.payment_processor_id
    FROM user_payment_processor pp
    WHERE "user".id = pp.user_id;

    DROP TABLE user_payment_processor;
    """)
