"""Add billing address ID to user table

Revision ID: 76e3b29b9419
Revises: 3d9bd1d89737
Create Date: 2025-06-30 13:55:10.958719

"""

# revision identifiers, used by Alembic.
revision = '76e3b29b9419'
down_revision = '3d9bd1d89737'

from alembic import op
import sqlalchemy as sa


def upgrade():
    op.execute("""

    ALTER TABLE "user"
    ADD COLUMN billing_address_id INTEGER REFERENCES billing_address(id);

    UPDATE "user"
    SET billing_address_id = billing_address.id
    FROM billing_address
    WHERE billing_address.user_id = "user".id;

    ALTER TABLE billing_address
    DROP CONSTRAINT billing_address_user_id_key;

    """)

def downgrade():
    op.execute("""

    ALTER TABLE "user"
    DROP COLUMN billing_address_id;

    ALTER TABLE billing_address
    ADD CONSTRAINT billing_address_user_id_key UNIQUE(user_id);

    """)
