"""Update user deletion cascades

Revision ID: a4bd02dd177b
Revises: a528ac9b0ec5
Create Date: 2025-07-08 09:58:45.334197

"""

# revision identifiers, used by Alembic.
revision = 'a4bd02dd177b'
down_revision = 'a528ac9b0ec5'

from alembic import op
import sqlalchemy as sa


def upgrade():
    op.execute("""
    ALTER TABLE user_payment_processor
    DROP CONSTRAINT user_payment_processor_user_id_fkey;

    ALTER TABLE user_payment_processor
    ADD CONSTRAINT user_payment_processor_user_id_fkey
    FOREIGN KEY (user_id) REFERENCES "user"(id) ON DELETE CASCADE;

    ALTER TABLE billing_address
    DROP CONSTRAINT billing_address_user_id_fkey;

    ALTER TABLE billing_address
    ADD CONSTRAINT billing_address_user_id_fkey
    FOREIGN KEY (user_id) REFERENCES "user"(id) ON DELETE SET NULL;

    ALTER TABLE invoice
    DROP CONSTRAINT invoice_user_id_fkey;

    ALTER TABLE invoice
    ADD CONSTRAINT invoice_user_id_fkey
    FOREIGN KEY (user_id) REFERENCES "user"(id) ON DELETE SET NULL;

    ALTER TABLE invoice
    DROP CONSTRAINT invoice_billing_address_id_fkey;

    ALTER TABLE invoice
    ADD CONSTRAINT invoice_billing_address_id_fkey
    FOREIGN KEY (billing_address_id) REFERENCES billing_address(id);
    """)


def downgrade():
    op.execute("""
    ALTER TABLE user_payment_processor
    DROP CONSTRAINT user_payment_processor_user_id_fkey;

    ALTER TABLE user_payment_processor
    ADD CONSTRAINT user_payment_processor_user_id_fkey
    FOREIGN KEY (user_id) REFERENCES "user"(id);

    ALTER TABLE billing_address
    DROP CONSTRAINT billing_address_user_id_fkey;

    ALTER TABLE billing_address
    ADD CONSTRAINT billing_address_user_id_fkey
    FOREIGN KEY (user_id) REFERENCES "user"(id) ON DELETE CASCADE;

    ALTER TABLE invoice
    DROP CONSTRAINT invoice_user_id_fkey;

    ALTER TABLE invoice
    ADD CONSTRAINT invoice_user_id_fkey
    FOREIGN KEY (user_id) REFERENCES "user"(id) ON DELETE CASCADE;

    ALTER TABLE invoice
    DROP CONSTRAINT invoice_billing_address_id_fkey;

    ALTER TABLE invoice
    ADD CONSTRAINT invoice_billing_address_id_fkey
    FOREIGN KEY (billing_address_id) REFERENCES billing_address(id) ON DELETE SET NULL;
    """)
