"""Add payment outcome to subscription

Revision ID: cb86df28b227
Revises: 0156e5c17226
Create Date: 2025-04-07 09:41:35.059308

"""

# revision identifiers, used by Alembic.
revision = 'cb86df28b227'
down_revision = '0156e5c17226'

from alembic import op
import sqlalchemy as sa


def upgrade():
    op.execute("""
    CREATE TYPE payment_outcome AS ENUM (
        'PENDING',
        'CANCELLED',
        'PROCESSING',
        'FAILED',
        'SUCCEEDED'
    );

    ALTER TABLE subscription
    ADD COLUMN payment_intent text,
    ADD COLUMN payment_outcome payment_outcome,
    ADD COLUMN payment_error text;

    UPDATE subscription SET payment_outcome = 'SUCCEEDED';

    ALTER TABLE subscription
    ALTER COLUMN payment_outcome SET NOT NULL;
    """)


def downgrade():
    op.execute("""
    ALTER TABLE subscription
    DROP COLUMN payment_intent,
    DROP COLUMN payment_outcome,
    DROP COLUMN payment_error;

    DROP TYPE payment_outcome;
    """)
