import sqlalchemy as sa
import sqlalchemy_utils as sau
from srht.database import Base
from enum import StrEnum

class PaymentInterval(StrEnum):
    monthly = 'MONTHLY'
    annually = 'ANNUALLY'

class PaymentCurrency(StrEnum):
    USD = 'USD'
    EUR = 'EUR'

class SubscriptionStatus(StrEnum):
    PENDING = 'PENDING'
    SETTLEMENT = 'SETTLEMENT'
    ACTIVE = 'ACTIVE'
    INACTIVE = 'INACTIVE'

class Subscription(Base):
    __tablename__ = "subscription"
    id = sa.Column(sa.Integer, primary_key=True)
    user_id = sa.Column(sa.Integer, sa.ForeignKey('user.id'))
    user = sa.orm.relationship("User")
    status = sa.Column(
            sau.ChoiceType(SubscriptionStatus, impl=sa.String()),
            nullable=False,
            server_default='PENDING')
    payment_intent = sa.Column(sa.Text)
